// Unit: BiampTesira

var biampDriver = IR.GetDevice("BiampTesira");

var biampLabelConst =    [  '',
                            'input_1_lev','input_1_mute',        //INPUT_1
                            'input_usb_lev','input_usb_mute',    //INPUT_USB
                            'out_1_lev','out_1_mute',            //OUT_1
                            'out_usb_lev','out_usb_mute',       //OUT_USB 
                            'input_2_lev','input_2_mute'        //SHARE
                         ];
var biampInstanceTag =   [  '',
                             'Level9',    //INPUT_1
                             'Level6',    //INPUT_USB
                             'Level8',    //OUT_1
                             'Level4',    //OUT_USB
                             'Level10'    //SHARE
                         ];
var biampTagFB =         [  '',
                            'biamp_input_1_lev_fb','biamp_input_1_mute_fb',
                            'biamp_input_usb_lev_fb','biamp_input_usb_mute_fb',
                            'biamp_out_1_lev_fb','biamp_out_1_mute_fb',
                            'biamp_out_usb_lev_fb','biamp_out_usb_mute_fb',
                            'biamp_input_2_lev_fb','biamp_input_2_mute_fb'
                          ]; 


var flsgTelnetAut = 0;
var DoTerminalType = [0xFF, 0xFD, 0x18];
var ATerminalType = [0xFF, 0xFC, 0x18];
var DoTerminalSpeed= [0xFF, 0xFD, 0x20]; 
var ATerminalSpeed= [0xFF, 0xFC, 0x20];
var DoXDisplayLocation= [0xFF, 0xFD, 0x23];
var AXDisplayLocation= [0xFF, 0xFC, 0x23]; 
var DoNewEnvironmentOption = [0xFF, 0xFD, 0x27]; 
var ANewEnvironmentOption = [0xFF, 0xFC, 0x27]; 
var DoEnvironmentOption = [0xFF, 0xFD, 0x24]; 
var AEnvironmentOption = [0xFF, 0xFC, 0x24]; 
var WillSuppressGoAhead = [0xFF, 0xFB, 0x03];
var ASuppressGoAhead = [0xFF, 0xFE, 0x03];
var DoEcho = [0xFF, 0xFB, 0x01];
var AEcho = [0xFF, 0xFC, 0x01];
var DoLinemode = [0xFF, 0xFD, 0x22];
var ALinemode = [0xFF, 0xFC, 0x22];
var DoNegotiateAboutWindowSize = [0xFF, 0xFD, 0x1F];
var ANegotiateAboutWindowSize = [0xFF, 0xFC, 0x1F];
var WillStatus = [0xFF, 0xFB, 0x05];
var AStatus = [0xFF, 0xFE, 0x05];
var DoRemoteFlowControl = [0xFF, 0xFD, 0x21];
var ARemoteFlowControl = [0xFF, 0xFC, 0x21];
var DoTimingMark = [0xFF, 0xFD, 0x06];
var ATimingMark = [0xFF, 0xFC, 0x06];
var DoBinaryTransmission = [0xFF, 0xFD, 0x00];
var ABinaryTransmission = [0xFF, 0xFC, 0x00];
var WelcomeTesira1Part = [0x00, 0x0D, 0x0A];

//var dataToTextTable="test";
var enableRx=0;

IR.AddListener(IR.EVENT_START, 0, function () {
//     dataToTextTable[1] = DoTerminalType[0].toString()+","+DoTerminalType[1].toString()+","+DoTerminalType[2].toString();
});

IR.AddListener(IR.EVENT_RECEIVE_DATA, biampDriver, function(data){ 


//    IR.Log(DoTerminalType[0].toString()+DoTerminalType[1].toString()+DoTerminalType[2].toString());
    if(flsgTelnetAut==0){
        var dataToTextRx = data.toString();
    
        IR.Log("TesiraRX data="+data);
        dataToTextTable = DoTerminalType[0].toString()+","+DoTerminalType[1].toString()+","+DoTerminalType[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
             IR.GetDevice("BiampTesira").Send(ATerminalType);
        }
        dataToTextTable = DoTerminalSpeed[0].toString()+","+DoTerminalSpeed[1].toString()+","+DoTerminalSpeed[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(ATerminalSpeed);
        }
        dataToTextTable = DoXDisplayLocation[0].toString()+","+DoXDisplayLocation[1].toString()+","+DoXDisplayLocation[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(AXDisplayLocation);
        }
        dataToTextTable = DoNewEnvironmentOption[0].toString()+","+DoNewEnvironmentOption[1].toString()+","+DoNewEnvironmentOption[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(ANewEnvironmentOption);
        }
        dataToTextTable = DoEnvironmentOption[0].toString()+","+DoEnvironmentOption[1].toString()+","+DoEnvironmentOption[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(AEnvironmentOption);
        }
        dataToTextTable = WillSuppressGoAhead[0].toString()+","+WillSuppressGoAhead[1].toString()+","+WillSuppressGoAhead[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(ASuppressGoAhead);
        }
        dataToTextTable = DoEcho[0].toString()+","+DoEcho[1].toString()+","+DoEcho[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(AEcho);
        }
        dataToTextTable = DoLinemode[0].toString()+","+DoLinemode[1].toString()+","+DoLinemode[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(ALinemode);
        }
        dataToTextTable = DoNegotiateAboutWindowSize[0].toString()+","+DoNegotiateAboutWindowSize[1].toString()+","+DoNegotiateAboutWindowSize[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(ANegotiateAboutWindowSize);
        }
        dataToTextTable = WillStatus[0].toString()+","+WillStatus[1].toString()+","+WillStatus[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(AStatus);
        }
        dataToTextTable = DoRemoteFlowControl[0].toString()+","+DoRemoteFlowControl[1].toString()+","+DoRemoteFlowControl[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(ARemoteFlowControl);
        }
        dataToTextTable = DoTimingMark[0].toString()+","+DoTimingMark[1].toString()+","+DoTimingMark[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(ATimingMark);
        }
        dataToTextTable = DoBinaryTransmission[0].toString()+","+DoBinaryTransmission[1].toString()+","+DoBinaryTransmission[2].toString();
        if(dataToTextRx.indexOf(dataToTextTable)>=0){ 
            IR.GetDevice("BiampTesira").Send(ABinaryTransmission);
        }  
        
        
                
  }
}); 

function biampInit(){
//Level5 get level 1
//Level6 unsubscribe level 1 input_1_lev
    IR.SetTimeout(500, function(){
        biampDriver.Send([biampInstanceTag[1], ' subscribe level 1 ',biampLabelConst[1],' 500', 0x0A]);      
        IR.SetTimeout(500, function(){
            biampDriver.Send([biampInstanceTag[1], ' subscribe mute 1 ',biampLabelConst[2],' 500', 0x0A]); 
            IR.SetTimeout(500, function(){
                biampDriver.Send([biampInstanceTag[2], ' subscribe level 1 ',biampLabelConst[3],' 500', 0x0A]); 
                IR.SetTimeout(500, function(){
                    biampDriver.Send([biampInstanceTag[2], ' subscribe mute 1 ',biampLabelConst[4],' 500', 0x0A]); 
                    IR.SetTimeout(500, function(){
                        biampDriver.Send([biampInstanceTag[3], ' subscribe level 1 ',biampLabelConst[5],' 500', 0x0A])
                        IR.SetTimeout(500, function(){
                            biampDriver.Send([biampInstanceTag[3], ' subscribe mute 1 ',biampLabelConst[6],' 500', 0x0A]); 
                            IR.SetTimeout(500, function(){
                                biampDriver.Send([biampInstanceTag[4], ' subscribe level 1 ',biampLabelConst[7],' 500', 0x0A])
                                IR.SetTimeout(500, function(){
                                    biampDriver.Send([biampInstanceTag[4], ' subscribe mute 1 ',biampLabelConst[8],' 500', 0x0A]);    
                                    IR.SetTimeout(500, function(){
                                         biampDriver.Send([biampInstanceTag[5], ' subscribe mute 1 ',biampLabelConst[10],' 500', 0x0A]);    
                                         IR.SetTimeout(500, function(){
                                            biampDriver.Send([biampInstanceTag[5], ' subscribe level 1 ',biampLabelConst[9],' 500', 0x0A]) 
                                         });
                                    });   
                                });    
                            });    
                        });
                    }); 
                });    
            });
        });
    });   
}

function biampUnInit(){
//Level5 get level 1
    IR.SetTimeout(500, function(){
        biampDriver.Send([biampInstanceTag[1], ' unsubscribe level 1 ',biampLabelConst[1],'', 0x0A]);      
        IR.SetTimeout(500, function(){
            biampDriver.Send([biampInstanceTag[1], ' unsubscribe mute 1 ',biampLabelConst[2],'', 0x0A]); 
            IR.SetTimeout(500, function(){
                biampDriver.Send([biampInstanceTag[2], ' unsubscribe level 1 ',biampLabelConst[3],'', 0x0A]); 
                IR.SetTimeout(500, function(){
                    biampDriver.Send([biampInstanceTag[2], ' unsubscribe mute 1 ',biampLabelConst[4],'', 0x0A]); 
                    IR.SetTimeout(500, function(){
                        biampDriver.Send([biampInstanceTag[3], ' unsubscribe level 1 ',biampLabelConst[5],'', 0x0A])
                        IR.SetTimeout(500, function(){
                            biampDriver.Send([biampInstanceTag[3], ' unsubscribe mute 1 ',biampLabelConst[6],'', 0x0A]); 
                            IR.SetTimeout(500, function(){
                                biampDriver.Send([biampInstanceTag[4], ' unsubscribe level 1 ',biampLabelConst[7],'', 0x0A])
                                IR.SetTimeout(500, function(){
                                    biampDriver.Send([biampInstanceTag[4], ' unsubscribe mute 1 ',biampLabelConst[8],'', 0x0A]);    
                                });    
                            });    
                        });
                    }); 
                });    
            });
        });
    }); 

}
IR.AddListener(IR.EVENT_ONLINE, biampDriver, function()
{    
//Level4 subscribe level 1 input1_lev 500\0A   Lev
//Level1 subscribe mute 1 input1_mute 500\0A Mute
    flsgTelnetAut=0;
    
    IR.SetTimeout(5000, function(){
//        biampUnInit();
        biampInit();
//        IR.SetTimeout(10000, function(){
//           biampInit();
//        });
    });
});

IR.AddListener(IR.EVENT_OFFLINE, biampDriver, function()
{    
    flsgTelnetAut=0;
});

IR.AddListener(IR.EVENT_RECEIVE_TEXT, biampDriver, function(text){ 
    IR.Log("TesiraRX="+text);
    //Welcome to the Tesira Text Protocol Server
    
    if((text.length>5)&&(enableRx==0)){
        if(text.indexOf("Welcome to the Tesira Text Protocol Server")>=0){
            IR.Log("Tesira connected");
            flsgTelnetAut=1;
        }
            IR.Log("TesiraRX="+text);
            var findValue = text.indexOf("value");
            var findDoublePoint = text.indexOf(":",findValue);
            var valueText = text.substr(findDoublePoint+1, text.length-(findDoublePoint+1));
            
            IR.Log("valueText="+valueText);
            
            ////INPUT_1
            if(text.indexOf(biampLabelConst[1])>=0){
                var findPoint = valueText.indexOf(".");
                var roundLevNotScale = parseInt(valueText.substr(0, findPoint));
                biampDriver.SetFeedback(biampTagFB[1], roundLevNotScale);
            }else if(text.indexOf(biampLabelConst[2])>=0){
                if(valueText.indexOf("true")>=0){
                    biampDriver.SetFeedback(biampTagFB[2], 1);
                }else if(valueText.indexOf("false")>=0){
                    biampDriver.SetFeedback(biampTagFB[2], 0);
                }
            }
            //INPUT_USB
            else if(text.indexOf(biampLabelConst[3])>=0){
                var findPoint = valueText.indexOf(".");
                var roundLevNotScale = parseInt(valueText.substr(0, findPoint));
                biampDriver.SetFeedback(biampTagFB[3], roundLevNotScale);
            }else if(text.indexOf(biampLabelConst[4])>=0){
                if(valueText.indexOf("true")>=0){
                    biampDriver.SetFeedback(biampTagFB[4], 1);
                }else if(valueText.indexOf("false")>=0){
                    biampDriver.SetFeedback(biampTagFB[4], 0);
                }
            }
            //OUT_1
            else if(text.indexOf(biampLabelConst[5])>=0){
                var findPoint = valueText.indexOf(".");
                var roundLevNotScale = parseInt(valueText.substr(0, findPoint));
                biampDriver.SetFeedback(biampTagFB[5], roundLevNotScale);
            }else if(text.indexOf(biampLabelConst[6])>=0){
                if(valueText.indexOf("true")>=0){
                    biampDriver.SetFeedback(biampTagFB[6], 1);
                }else if(valueText.indexOf("false")>=0){
                    biampDriver.SetFeedback(biampTagFB[6], 0);
                }
            }
            //OUT_USB
            else if(text.indexOf(biampLabelConst[7])>=0){
                var findPoint = valueText.indexOf(".");
                var roundLevNotScale = parseInt(valueText.substr(0, findPoint));
                biampDriver.SetFeedback(biampTagFB[7], roundLevNotScale);
            }else if(text.indexOf(biampLabelConst[8])>=0){
                if(valueText.indexOf("true")>=0){
                    biampDriver.SetFeedback(biampTagFB[8], 1);
                }else if(valueText.indexOf("false")>=0){
                    biampDriver.SetFeedback(biampTagFB[8], 0);
                }
            }
            ////SHARE
            if(text.indexOf(biampLabelConst[9])>=0){
                var findPoint = valueText.indexOf(".");
                var roundLevNotScale = parseInt(valueText.substr(0, findPoint));
                biampDriver.SetFeedback(biampTagFB[9], roundLevNotScale);
            }else if(text.indexOf(biampLabelConst[10])>=0){
                if(valueText.indexOf("true")>=0){
                    biampDriver.SetFeedback(biampTagFB[10], 1);
                }else if(valueText.indexOf("false")>=0){
                    biampDriver.SetFeedback(biampTagFB[10], 0);
                }
            }            
    }
    
}); 

function scaleLevel(tagFb, levText){
    IR.Log("levText="+levText);
    if(levText.indexOf("-") >= 0){
        var sigMinus = levText.indexOf("-");
        var findPoint = levText.indexOf(".");
        var roundLevNotScale = parseInt(levText.substr(sigMinus+1, findPoint));
        IR.Log("roundTex -t="+roundLevNotScale);
        var outLevel =  parseInt(roundLevNotScale - 100);
        IR.Log("outLevel -="+outLevel);
    }else{
        var findPoint = levText.indexOf(".");
        var roundLevNotScale = parseInt(levText.substr(sigMinus+1, findPoint));
        IR.Log("roundTex ="+roundLevNotScale);
    }    
//    IR.GetDevice("BiampTesira").SetFeedback(biampTagFB[1], 0);
}

// Unit: GLobal Listener

IR.SetGlobalListener(IR.EVENT_GLOBAL_TAG_CHANGE, function(in_sName, in_sValue) {
   IR.Log("GL name="+in_sName);
   IR.Log("GL value ="+in_sValue);
//   IR.ClearInterval(timerRoland);
      switch(in_sName) {

        case "Server.Channels.BiampTesira.biamp_input_1_lev_set":
//            enableRx = 1;
            biampDriver.SetFeedback(biampTagFB[1], in_sValue);
            biampDriver.Send([biampInstanceTag[1], ' set level 1 ',in_sValue.toString(), 0x0A]);
        break; 
         
        case "Server.Channels.BiampTesira.biamp_input_1_mute_tg":    
//            enableRx = 1;
               if(biampDriver.GetFeedback("biamp_input_1_mute_fb") == 0){
                   biampDriver.Send([biampInstanceTag[1], ' set mute 1 true', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[2], 1); 
               }else if(biampDriver.GetFeedback("biamp_input_1_mute_fb") == 1){
                   biampDriver.Send([biampInstanceTag[1], ' set mute 1 false', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[2], 0); 
               } 
        break;
        case "Server.Channels.BiampTesira.biamp_input_usb_lev_set": 
//            enableRx = 1;
               biampDriver.SetFeedback(biampTagFB[3], in_sValue);
               biampDriver.Send([biampInstanceTag[2], ' set level 1 ',in_sValue.toString(), 0x0A]);
        break;
        case "Server.Channels.BiampTesira.biamp_input_usb_mute_tg": 
//            enableRx = 1;
               if(biampDriver.GetFeedback(biampTagFB[4]) == 0){
                   biampDriver.Send([biampInstanceTag[2], ' set mute 1 true', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[4], 1); 
               }else if(biampDriver.GetFeedback(biampTagFB[4]) == 1){
                   biampDriver.Send([biampInstanceTag[2], ' set mute 1 false', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[4], 0); 
               } 
        break;
        case "Server.Channels.BiampTesira.biamp_out_1_lev_set": 
//            enableRx = 1;
               biampDriver.SetFeedback(biampTagFB[5], in_sValue);
               biampDriver.Send([biampInstanceTag[3], ' set level 1 ',in_sValue.toString(), 0x0A]);
        break;
        case "Server.Channels.BiampTesira.biamp_out_1_mute_tg": 
 //           enableRx = 1;
               if(biampDriver.GetFeedback(biampTagFB[6]) == 0){
                   biampDriver.Send([biampInstanceTag[3], ' set mute 1 true', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[6], 1); 
               }else if(biampDriver.GetFeedback(biampTagFB[6]) == 1){
                   biampDriver.Send([biampInstanceTag[3], ' set mute 1 false', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[6], 0); 
               } 
        break;
        case "Server.Channels.BiampTesira.biamp_out_1_mute_on": 
 //           enableRx = 1;
                   biampDriver.SetFeedback(biampTagFB[6], 1); 
        break;
        case "Server.Channels.BiampTesira.biamp_out_1_mute_off": 
 //           enableRx = 1;
                   biampDriver.SetFeedback(biampTagFB[6], 0); 
        break;
        case "Server.Channels.BiampTesira.biamp_out_usb_lev_set": 
            enableRx = 1;
               biampDriver.SetFeedback(biampTagFB[7], in_sValue);
               biampDriver.Send([biampInstanceTag[4], ' set level 1 ',in_sValue.toString(), 0x0A]);
        break;
        case "Server.Channels.BiampTesira.biamp_out_usb_mute_tg": 
 //           enableRx = 1;
               if(biampDriver.GetFeedback(biampTagFB[8]) == 0){
                   biampDriver.Send([biampInstanceTag[4], ' set mute 1 true', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[8], 1); 
               }else if(biampDriver.GetFeedback(biampTagFB[8]) == 1){
                   biampDriver.Send([biampInstanceTag[4], ' set mute 1 false', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[8], 0); 
               } 
        break; 
        case "Server.Channels.BiampTesira.biamp_input_2_lev_set": 
//            enableRx = 1;
            biampDriver.SetFeedback(biampTagFB[9], in_sValue);
            biampDriver.Send([biampInstanceTag[5], ' set level 1 ',in_sValue.toString(), 0x0A]);
        break;
        case "Server.Channels.BiampTesira.biamp_input_2_mute_tg": 
//            enableRx = 1;
               if(biampDriver.GetFeedback("biamp_input_2_mute_fb") == 0){
                   biampDriver.Send([biampInstanceTag[5], ' set mute 1 true', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[10], 1); 
               }else if(biampDriver.GetFeedback("biamp_input_2_mute_fb") == 1){
                   biampDriver.Send([biampInstanceTag[5], ' set mute 1 false', 0x0A]);
                   biampDriver.SetFeedback(biampTagFB[10], 0); 
               } 
        break;
        default:
        break;
    }  
    enableRx = 0;

});


//AC
IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_input_1_lev_set");
IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_input_1_mute_tg");

IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_input_usb_lev_set");
IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_input_usb_mute_tg");

IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_out_1_lev_set");
IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_out_1_mute_tg");
IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_out_1_mute_on");
IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_out_1_mute_off");

IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_out_usb_lev_set");
IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_out_usb_mute_tg");

IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_input_2_lev_set");
IR.SubscribeTagChange("Server.Channels.BiampTesira.biamp_input_2_mute_tg");